/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var DownloadUrl = function(){

	/**
	 * 	Private properties and methods.
	 */
	
	var config = {
		
	}
	
	var get = function (cdpId, catalogId, downloadLink) {
		var self = this;

		document.title = window.opener.AME.getTitle();
		$('#modal-message').attr('value', 'Starting Download. Please Wait...');
		
		var token = self.getToken();
		
		var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
					  .createInstance(Components.interfaces.nsIXMLHttpRequest);
		request.onload = function(aEvent) {
			var text = aEvent.target.responseText;
			try{
				var jsObject = JSON.parse(text);
			}
			catch(e){
				// Response is not a proper JSON object.
				window.arguments[0].out.error_message = 'There is some problem for downloading the book. Please try again later.';
				window.arguments[0].out.out = false;
				window.close();
			}
			
			var status = jsObject.status;
			var downloadUrl, raf;
			if(!status){
				window.arguments[0].out.error_message = jsObject.message;
				window.arguments[0].out.out = false;
				window.close();
			}
			else{
				if(jsObject.raf == '') {
					window.arguments[0].out.error_message = 'There is some problem for downloading the book. Please try again later.';
					window.arguments[0].out.out = false;
					window.close();
				}
				window.arguments[0].out.raf = jsObject.raf;
				window.arguments[0].out.download_url = jsObject.download_url;
				window.arguments[0].out.out = true;
				window.close();
			}
		};
		request.onerror = function(aEvent) {
			window.arguments[0].out.error_message = 'There is some problem for downloading the book. Please try again later.';
			window.arguments[0].out.out = false;
			window.close();
		};
		request.open("POST", downloadLink, true);
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.send("readerid=" + token + "&cdpid=" + cdpId + "&catalogid=" + catalogId);
	}
	
	var getToken = function () {
		var self = this;
		
		var fileObj = window.opener.getFileObject(window.opener.AME.getDbFilePath());
		table_name = 'System';
		var conditions = new Array(['key', 'token', 'TEXT']);
		var values = ['value'];
		
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name, conditions);
		var value;
		while (statement.executeStep()) {
			value = statement.row.value
		}
		statement.finalize();
		
		return value;
	}
	
	return{
		get: get,
		getToken: getToken
	}
}();